#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */

int open_port(void) {
	int fd; /* File descriptor for the port */

	fd = open("/dev/ttyUSB0", O_RDWR | O_NOCTTY | O_NDELAY);
	if (fd == -1)
		perror("open_port: Unable to open /dev/ttyUSB0 - ");
	else
		fcntl(fd, F_SETFL, 0);
	return (fd);
}

int main() {
	int fd = open_port();

	struct termios options;
	tcgetattr(fd, &options);

	cfsetispeed(&options, B115200);
	cfsetospeed(&options, B115200);

	options.c_cflag |= (CLOCAL | CREAD);
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	options.c_cflag &= ~PARENB;
	options.c_cflag &= ~CSTOPB;
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);

	tcsetattr(fd, TCSANOW, &options);

	unsigned char x;
	read(fd, &x, 1);
	printf("%d\n", x);

	fclose(fopen("./uart.out", "w"));

	for(;;) {
		unsigned int y;
		for(x = 0; x < 4; x++) {
			unsigned char a;
			read(fd, &a, 1);
			y <<= 8;
			y |= a;
		}
		FILE* fp = fopen("./uart.out", "a");
		fprintf(fp, "%u\n", y);
		fclose(fp);
		//system("(cat /tmp/uart.out | sort -n | uniq) > ./uart.out");
		printf("= %10u\n", y);
	}
	close(fd);
}
